diff --git a/boost-build.jam b/boost-build.jam
index 02b750a..fb30e7b 100644
--- a/boost-build.jam
+++ b/boost-build.jam
@@ -43,7 +43,7 @@ local boost-build-src = [ if-has-file bootstrap.jam :
     [ MATCH --boost-build=(.*) : $(ARGV) ]
     $(BOOST_BUILD_PATH)
     $(BOOST_BUILD)
-    $(boost-src)/tools/build/v2
+    $(boost-src)/tools/build
     ] ;
 
 # error handling:
@@ -52,7 +52,7 @@ if ! $(boost-build-src)
   ECHO Unable to find the Boost.Build source tree in the locations searched. ;
   ECHO Try setting the environment variable BOOST_BUILD to point to your ;
   ECHO Boost.Build tree, or else invoke bjam with the --boost-build=path option. ;
-  ECHO The paths searched were [ MATCH --boost-build=(.*) : $(ARGV) ] $(BOOST_BUILD_PATH) $(BOOST_BUILD) $(boost-src)/tools/build/v2 ;
+  ECHO The paths searched were [ MATCH --boost-build=(.*) : $(ARGV) ] $(BOOST_BUILD_PATH) $(BOOST_BUILD) $(boost-src)/tools/build ;
   ECHO But bootstrap.jam was not found in any of these ;
   ECHO More failures will very likely follow... ;
 }
diff --git a/bootstrap.bat b/bootstrap.bat
index e8a1a95..605aa61 100644
--- a/bootstrap.bat
+++ b/bootstrap.bat
@@ -6,25 +6,25 @@ REM Distributed under the Boost Software License, Version 1.0.
 REM (See accompanying file LICENSE_1_0.txt or http://www.boost.org/LICENSE_1_0.txt)
 
 ECHO Building Boost.Build engine
-if exist ".\tools\build\v2\engine\bin.ntx86\b2.exe" del tools\build\v2\engine\bin.ntx86\b2.exe
-if exist ".\tools\build\v2\engine\bin.ntx86\bjam.exe" del tools\build\v2\engine\bin.ntx86\bjam.exe
-if exist ".\tools\build\v2\engine\bin.ntx86_64\b2.exe" del tools\build\v2\engine\bin.ntx86_64\b2.exe
-if exist ".\tools\build\v2\engine\bin.ntx86_64\bjam.exe" del tools\build\v2\engine\bin.ntx86_64\bjam.exe
-pushd tools\build\v2\engine
+if exist ".\tools\build\engine\bin.ntx86\b2.exe" del tools\build\engine\bin.ntx86\b2.exe
+if exist ".\tools\build\engine\bin.ntx86\bjam.exe" del tools\build\engine\bin.ntx86\bjam.exe
+if exist ".\tools\build\engine\bin.ntx86_64\b2.exe" del tools\build\engine\bin.ntx86_64\b2.exe
+if exist ".\tools\build\engine\bin.ntx86_64\bjam.exe" del tools\build\engine\bin.ntx86_64\bjam.exe
+pushd tools\build\engine
 
 call .\build.bat %* > ..\..\..\..\bootstrap.log
 @ECHO OFF
 
 popd
 
-if exist ".\tools\build\v2\engine\bin.ntx86\bjam.exe" (
-   copy .\tools\build\v2\engine\bin.ntx86\b2.exe . > nul
-   copy .\tools\build\v2\engine\bin.ntx86\bjam.exe . > nul
+if exist ".\tools\build\engine\bin.ntx86\bjam.exe" (
+   copy .\tools\build\engine\bin.ntx86\b2.exe . > nul
+   copy .\tools\build\engine\bin.ntx86\bjam.exe . > nul
    goto :bjam_built)
 
-if exist ".\tools\build\v2\engine\bin.ntx86_64\bjam.exe" (
-   copy .\tools\build\v2\engine\bin.ntx86_64\b2.exe . > nul
-   copy .\tools\build\v2\engine\bin.ntx86_64\bjam.exe . > nul
+if exist ".\tools\build\engine\bin.ntx86_64\bjam.exe" (
+   copy .\tools\build\engine\bin.ntx86_64\b2.exe . > nul
+   copy .\tools\build\engine\bin.ntx86_64\bjam.exe . > nul
    goto :bjam_built)
 
 goto :bjam_failure
diff --git a/bootstrap.sh b/bootstrap.sh
index 36e92ff..211aadf 100755
--- a/bootstrap.sh
+++ b/bootstrap.sh
@@ -185,7 +185,7 @@ my_dir="."
 
 # Determine the toolset, if not already decided
 if test "x$TOOLSET" = x; then
-  guessed_toolset=`$my_dir/tools/build/v2/engine/build.sh --guess-toolset`
+  guessed_toolset=`$my_dir/tools/build/engine/build.sh --guess-toolset`
   case $guessed_toolset in
     acc | darwin | gcc | como | mipspro | pathscale | pgi | qcc | vacpp )
     TOOLSET=$guessed_toolset
@@ -215,7 +215,7 @@ rm -f config.log
 if test "x$BJAM" = x; then
   echo -n "Building Boost.Build engine with toolset $TOOLSET... "
   pwd=`pwd`
-  (cd "$my_dir/tools/build/v2/engine" && ./build.sh "$TOOLSET") > bootstrap.log 2>&1
+  (cd "$my_dir/tools/build/engine" && ./build.sh "$TOOLSET") > bootstrap.log 2>&1
   if [ $? -ne 0 ]; then
       echo
       echo "Failed to build Boost.Build build engine" 
@@ -223,11 +223,11 @@ if test "x$BJAM" = x; then
       exit 1
   fi
   cd "$pwd"
-  arch=`cd $my_dir/tools/build/v2/engine && ./bootstrap/jam0 -d0 -f build.jam --toolset=$TOOLSET --toolset-root= --show-locate-target && cd ..`
-  BJAM="$my_dir/tools/build/v2/engine/$arch/b2"
-  echo "tools/build/v2/engine/$arch/b2"
+  arch=`cd $my_dir/tools/build/engine && ./bootstrap/jam0 -d0 -f build.jam --toolset=$TOOLSET --toolset-root= --show-locate-target && cd ..`
+  BJAM="$my_dir/tools/build/engine/$arch/b2"
+  echo "tools/build/engine/$arch/b2"
   cp "$BJAM" .
-  cp "$my_dir/tools/build/v2/engine/$arch/bjam" .
+  cp "$my_dir/tools/build/engine/$arch/bjam" .
 
 fi
 
@@ -394,4 +394,4 @@ Further information:
    - Boost.Build documentation:
      http://www.boost.org/boost-build2/doc/html/index.html
 
-EOF
\ No newline at end of file
+EOF