Index: boost/archive/basic_archive.hpp
===================================================================
--- boost/archive/basic_archive.hpp	(revision 48986)
+++ boost/archive/basic_archive.hpp	(working copy)
@@ -21,6 +21,12 @@
 #include <boost/noncopyable.hpp>
 
 #include <boost/archive/detail/auto_link_archive.hpp>
+
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -103,6 +109,10 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #include <boost/serialization/level.hpp>
 
 // set implementation level to primitive for all types
Index: boost/archive/basic_text_iprimitive.hpp
===================================================================
--- boost/archive/basic_text_iprimitive.hpp	(revision 48986)
+++ boost/archive/basic_text_iprimitive.hpp	(working copy)
@@ -50,6 +50,11 @@
 
 #include <boost/archive/archive_exception.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -141,4 +146,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pop pragams
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // BOOST_ARCHIVE_BASIC_TEXT_IPRIMITIVE_HPP
Index: boost/archive/basic_text_oprimitive.hpp
===================================================================
--- boost/archive/basic_text_oprimitive.hpp	(revision 48986)
+++ boost/archive/basic_text_oprimitive.hpp	(working copy)
@@ -51,6 +51,11 @@
 #include <boost/serialization/throw_exception.hpp>
 #include <boost/archive/archive_exception.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -186,4 +191,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // BOOST_ARCHIVE_BASIC_TEXT_OPRIMITIVE_HPP
Index: boost/archive/basic_xml_archive.hpp
===================================================================
--- boost/archive/basic_xml_archive.hpp	(revision 48986)
+++ boost/archive/basic_xml_archive.hpp	(working copy)
@@ -19,6 +19,11 @@
 #include <boost/archive/detail/auto_link_archive.hpp>
 #include <boost/archive/archive_exception.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost { 
@@ -63,5 +68,9 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // BOOST_ARCHIVE_BASIC_XML_TEXT_ARCHIVE_HPP
 
Index: boost/archive/detail/basic_iarchive.hpp
===================================================================
--- boost/archive/detail/basic_iarchive.hpp	(revision 48986)
+++ boost/archive/detail/basic_iarchive.hpp	(working copy)
@@ -24,6 +24,12 @@
 #include <boost/serialization/tracking_enum.hpp>
 #include <boost/archive/basic_archive.hpp>
 #include <boost/archive/detail/decl.hpp>
+
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -105,4 +111,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif //BOOST_ARCHIVE_DETAIL_BASIC_IARCHIVE_HPP
Index: boost/archive/detail/basic_iserializer.hpp
===================================================================
--- boost/archive/detail/basic_iserializer.hpp	(revision 48986)
+++ boost/archive/detail/basic_iserializer.hpp	(working copy)
@@ -22,6 +22,12 @@
 #include <boost/archive/detail/decl.hpp>
 #include <boost/archive/detail/basic_serializer.hpp>
 #include <boost/archive/detail/auto_link_archive.hpp>
+
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -83,4 +89,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#if defined(BOOST_MSVC)
+#  pragma warning(pop)
+#endif
+
 #endif // BOOST_ARCHIVE_DETAIL_BASIC_ISERIALIZER_HPP
Index: boost/archive/detail/basic_oarchive.hpp
===================================================================
--- boost/archive/detail/basic_oarchive.hpp	(revision 48986)
+++ boost/archive/detail/basic_oarchive.hpp	(working copy)
@@ -26,6 +26,11 @@
 #include <boost/archive/basic_archive.hpp>
 #include <boost/serialization/tracking_enum.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -100,4 +105,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#pragma warning(pop)
+#endif
+
 #endif //BOOST_ARCHIVE_BASIC_OARCHIVE_HPP
Index: boost/archive/detail/basic_oserializer.hpp
===================================================================
--- boost/archive/detail/basic_oserializer.hpp	(revision 48986)
+++ boost/archive/detail/basic_oserializer.hpp	(working copy)
@@ -22,6 +22,11 @@
 #include <boost/archive/detail/auto_link_archive.hpp>
 #include <boost/archive/detail/basic_serializer.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -80,4 +85,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#pragma warning(pop)
+#endif
+
 #endif // BOOST_SERIALIZATION_BASIC_OSERIALIZER_HPP
Index: boost/archive/detail/basic_pointer_iserializer.hpp
===================================================================
--- boost/archive/detail/basic_pointer_iserializer.hpp	(revision 48986)
+++ boost/archive/detail/basic_pointer_iserializer.hpp	(working copy)
@@ -20,6 +20,11 @@
 #include <boost/archive/detail/auto_link_archive.hpp>
 #include <boost/archive/detail/basic_serializer.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -61,4 +66,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // BOOST_ARCHIVE_BASIC_POINTER_ISERIALIZER_HPP
Index: boost/archive/detail/basic_pointer_oserializer.hpp
===================================================================
--- boost/archive/detail/basic_pointer_oserializer.hpp	(revision 48986)
+++ boost/archive/detail/basic_pointer_oserializer.hpp	(working copy)
@@ -20,6 +20,11 @@
 #include <boost/archive/detail/auto_link_archive.hpp>
 #include <boost/archive/detail/basic_serializer.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost {
@@ -59,4 +64,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#pragma warning(pop)
+#endif
+
 #endif // BOOST_ARCHIVE_BASIC_POINTER_OSERIALIZER_HPP
Index: boost/archive/detail/basic_serializer_map.hpp
===================================================================
--- boost/archive/detail/basic_serializer_map.hpp	(revision 48986)
+++ boost/archive/detail/basic_serializer_map.hpp	(working copy)
@@ -22,6 +22,11 @@
 #include <boost/utility.hpp>
 #include <boost/archive/detail/auto_link_archive.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/archive/detail/abi_prefix.hpp> // must be the last header
 
 namespace boost { 
@@ -56,4 +61,8 @@
 
 #include <boost/archive/detail/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#pragma warning(pop)
+#endif
+
 #endif // BOOST_TYPEINFO_EXTENDED_MAP_HPP
Index: boost/filesystem/operations.hpp
===================================================================
--- boost/filesystem/operations.hpp	(revision 48986)
+++ boost/filesystem/operations.hpp	(working copy)
@@ -34,6 +34,11 @@
 #  endif
 #endif
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/config/abi_prefix.hpp> // must be the last #include
 
 # ifdef BOOST_NO_STDC_NAMESPACE
@@ -1168,4 +1173,9 @@
 
 
 #include <boost/config/abi_suffix.hpp> // pops abi_prefix.hpp pragmas
+
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // BOOST_FILESYSTEM_OPERATIONS_HPP
Index: boost/filesystem/path.hpp
===================================================================
--- boost/filesystem/path.hpp	(revision 48986)
+++ boost/filesystem/path.hpp	(working copy)
@@ -35,6 +35,11 @@
 #   include <locale>
 # endif
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/config/abi_prefix.hpp> // must be the last #include
 
 //----------------------------------------------------------------------------//
@@ -1485,4 +1490,8 @@
 
 #include <boost/config/abi_suffix.hpp> // pops abi_prefix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // BOOST_FILESYSTEM_PATH_HPP
Index: boost/serialization/extended_type_info.hpp
===================================================================
--- boost/serialization/extended_type_info.hpp	(revision 48986)
+++ boost/serialization/extended_type_info.hpp	(working copy)
@@ -24,12 +24,13 @@
 #include <boost/config.hpp>
 #include <boost/serialization/config.hpp>
 
-#include <boost/config/abi_prefix.hpp> // must be the last header
 #ifdef BOOST_MSVC
 #  pragma warning(push)
-#  pragma warning(disable : 4251 4231 4660 4275)
+#  pragma warning(disable : 4103 4251 4231 4660 4275)
 #endif
 
+#include <boost/config/abi_prefix.hpp> // must be the last header
+
 #define BOOST_SERIALIZATION_MAX_KEY_SIZE 128
 
 namespace boost { 
@@ -88,11 +89,11 @@
 } // namespace serialization 
 } // namespace boost
 
+#include <boost/config/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
+
 #ifdef BOOST_MSVC
 #pragma warning(pop)
 #endif
 
-#include <boost/config/abi_suffix.hpp> // pops abi_suffix.hpp pragmas
-
 #endif // BOOST_SERIALIZATION_EXTENDED_TYPE_INFO_HPP
 
Index: boost/system/error_code.hpp
===================================================================
--- boost/system/error_code.hpp	(revision 48986)
+++ boost/system/error_code.hpp	(working copy)
@@ -29,6 +29,11 @@
 #  error BOOST_POSIX_API or BOOST_WINDOWS_API must be defined
 #endif
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 #include <boost/config/abi_prefix.hpp> // must be the last #include
 
 namespace boost
@@ -491,6 +496,10 @@
 
 #include <boost/config/abi_suffix.hpp> // pops abi_prefix.hpp pragmas
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 # ifdef BOOST_ERROR_CODE_HEADER_ONLY
 #   include <boost/../libs/system/src/error_code.cpp>
 # endif
Index: boost/wave/cpplexer/re2clex/aq.hpp
===================================================================
--- boost/wave/cpplexer/re2clex/aq.hpp	(revision 48986)
+++ boost/wave/cpplexer/re2clex/aq.hpp	(working copy)
@@ -15,6 +15,11 @@
 #include <boost/wave/wave_config.hpp>
 #include <cstdlib>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 // this must occur after all of the includes and before any code appears
 #ifdef BOOST_HAS_ABI_HEADERS
 #include BOOST_ABI_PREFIX
@@ -61,4 +66,8 @@
 #include BOOST_ABI_SUFFIX
 #endif
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // !defined(AQ_HPP_A21D9145_B643_44C0_81E7_DB346DD67EE1_INCLUDED)
Index: boost/wave/language_support.hpp
===================================================================
--- boost/wave/language_support.hpp	(revision 48986)
+++ boost/wave/language_support.hpp	(working copy)
@@ -13,6 +13,11 @@
 
 #include <boost/wave/wave_config.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+ 
 // this must occur after all of the includes and before any code appears
 #ifdef BOOST_HAS_ABI_HEADERS
 #include BOOST_ABI_PREFIX
@@ -182,4 +187,8 @@
 #include BOOST_ABI_SUFFIX
 #endif
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // !defined(LANGUAGE_SUPPORT_HPP_93EDD057_2DEF_44BC_BC9F_FDABB9F51AFA_INCLUDED)
Index: boost/wave/token_ids.hpp
===================================================================
--- boost/wave/token_ids.hpp	(revision 48986)
+++ boost/wave/token_ids.hpp	(working copy)
@@ -17,6 +17,11 @@
 
 #include <boost/wave/wave_config.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 // this must occur after all of the includes and before any code appears
 #ifdef BOOST_HAS_ABI_HEADERS
 #include BOOST_ABI_PREFIX
@@ -343,5 +348,9 @@
 #include BOOST_ABI_SUFFIX
 #endif
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // !defined(TOKEN_IDS_HPP_414E9A58_F079_4789_8AFF_513815CE475B_INCLUDED)
 
Index: boost/wave/util/file_position.hpp
===================================================================
--- boost/wave/util/file_position.hpp	(revision 48986)
+++ boost/wave/util/file_position.hpp	(working copy)
@@ -24,6 +24,11 @@
 #include <boost/serialization/serialization.hpp>
 #endif
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 // this must occur after all of the includes and before any code appears
 #ifdef BOOST_HAS_ABI_HEADERS
 #include BOOST_ABI_PREFIX
@@ -225,4 +230,8 @@
 #include BOOST_ABI_SUFFIX
 #endif
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // !defined(FILE_POSITION_H_52BDEDF7_DAD3_4F24_802F_E66BB8098F68_INCLUDED)
Index: boost/wave/util/flex_string.hpp
===================================================================
--- boost/wave/util/flex_string.hpp	(revision 48986)
+++ boost/wave/util/flex_string.hpp	(working copy)
@@ -103,6 +103,11 @@
 #include <cstring>
 #include <cstdlib>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 // this must occur after all of the includes and before any code appears
 #ifdef BOOST_HAS_ABI_HEADERS
 #include BOOST_ABI_PREFIX
@@ -2536,4 +2541,8 @@
 #include BOOST_ABI_SUFFIX
 #endif
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
+
 #endif // FLEX_STRING_INC_
Index: libs/wave/src/cpplexer/re2clex/aq.cpp
===================================================================
--- libs/wave/src/cpplexer/re2clex/aq.cpp	(revision 48986)
+++ libs/wave/src/cpplexer/re2clex/aq.cpp	(working copy)
@@ -17,6 +17,11 @@
 
 #include <boost/assert.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 // this must occur after all of the includes and before any code appears
 #ifdef BOOST_HAS_ABI_HEADERS
 #include BOOST_ABI_PREFIX
@@ -230,3 +235,6 @@
 #include BOOST_ABI_SUFFIX
 #endif
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
Index: libs/wave/src/token_ids.cpp
===================================================================
--- libs/wave/src/token_ids.cpp	(revision 48986)
+++ libs/wave/src/token_ids.cpp	(working copy)
@@ -18,6 +18,11 @@
 #include <boost/wave/wave_config.hpp>
 #include <boost/wave/token_ids.hpp>
 
+#if defined(BOOST_MSVC)
+#  pragma warning(push)
+#  pragma warning(disable:4103) //alignment changed after including header, may be due to missing #pragma pack(pop)
+#endif
+
 // this must occur after all of the includes and before any code appears
 #ifdef BOOST_HAS_ABI_HEADERS
 #include BOOST_ABI_PREFIX
@@ -416,4 +421,8 @@
 #include BOOST_ABI_SUFFIX
 #endif
 
+#ifdef BOOST_MSVC
+#  pragma warning(pop)
+#endif
 
+