Index: test/test_add.cpp
===================================================================
--- test/test_add.cpp	(revision 61695)
+++ test/test_add.cpp	(working copy)
@@ -14,7 +14,7 @@
 #include <boost/xint/integer.hpp>
 #include <boost/xint/fixed_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 #include <iostream>
Index: test/test_bit_manipulations.cpp
===================================================================
--- test/test_bit_manipulations.cpp	(revision 61695)
+++ test/test_bit_manipulations.cpp	(working copy)
@@ -14,7 +14,7 @@
 #include <boost/xint/integer.hpp>
 #include <boost/xint/fixed_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 #include <iostream>
Index: test/test_compare.cpp
===================================================================
--- test/test_compare.cpp	(revision 61695)
+++ test/test_compare.cpp	(working copy)
@@ -18,7 +18,7 @@
 #include <boost/xint/integer.hpp>
 #include <boost/xint/fixed_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 namespace boost {
Index: test/test_convert.cpp
===================================================================
--- test/test_convert.cpp	(revision 61695)
+++ test/test_convert.cpp	(working copy)
@@ -15,7 +15,7 @@
 #include <boost/xint/nothrow_integer.hpp>
 #include <boost/xint/fixed_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 #include <iostream>
Index: test/test_divide.cpp
===================================================================
--- test/test_divide.cpp	(revision 61695)
+++ test/test_divide.cpp	(working copy)
@@ -16,7 +16,7 @@
 #include <boost/xint/integer.hpp>
 #include <boost/xint/random.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 #include <iostream>
Index: test/test_fixed.cpp
===================================================================
--- test/test_fixed.cpp	(revision 61695)
+++ test/test_fixed.cpp	(working copy)
@@ -21,7 +21,7 @@
 
 #include <iomanip>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 #include <boost/test/output_test_stream.hpp>
 
Index: test/test_main.cpp
===================================================================
--- test/test_main.cpp	(revision 61695)
+++ test/test_main.cpp	(working copy)
@@ -19,7 +19,7 @@
 
 #if 1
     #define BOOST_TEST_MAIN
-    #define BOOST_TEST_DYN_LINK
+    #define BOOST_TEST_MAIN
     #include <boost/test/unit_test.hpp>
 #else
     #include <boost/xint/xint.hpp>
Index: test/test_misc.cpp
===================================================================
--- test/test_misc.cpp	(revision 61695)
+++ test/test_misc.cpp	(working copy)
@@ -18,7 +18,7 @@
 #include <boost/xint/integer.hpp>
 #include <boost/xint/fixed_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 namespace boost {
Index: test/test_modular.cpp
===================================================================
--- test/test_modular.cpp	(revision 61695)
+++ test/test_modular.cpp	(working copy)
@@ -13,7 +13,7 @@
 
 #include <boost/xint/integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 namespace boost {
Index: test/test_monty.cpp
===================================================================
--- test/test_monty.cpp	(revision 61695)
+++ test/test_monty.cpp	(working copy)
@@ -15,7 +15,7 @@
 #include <boost/xint/random.hpp>
 #include <boost/xint/monty.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 #include <iostream>
Index: test/test_multiply.cpp
===================================================================
--- test/test_multiply.cpp	(revision 61695)
+++ test/test_multiply.cpp	(working copy)
@@ -16,7 +16,7 @@
 #include <boost/xint/random.hpp>
 #include <boost/xint/fixed_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 #include <iostream>
Index: test/test_powers.cpp
===================================================================
--- test/test_powers.cpp	(revision 61695)
+++ test/test_powers.cpp	(working copy)
@@ -14,7 +14,7 @@
 #include <boost/xint/integer.hpp>
 #include <boost/xint/fixed_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 namespace boost {
Index: test/test_streams.cpp
===================================================================
--- test/test_streams.cpp	(revision 61695)
+++ test/test_streams.cpp	(working copy)
@@ -14,7 +14,7 @@
 #include <boost/xint/integer.hpp>
 #include <boost/xint/nothrow_integer.hpp>
 
-#define BOOST_TEST_DYN_LINK
+#define BOOST_TEST_MAIN
 #include <boost/test/unit_test.hpp>
 
 #include <iostream>